// empeg flash downloader (hugo@empeg.com)
// Modified by Tony Fabris for Win32 only
//
// (C) 1999 empeg ltd
//
// unitdy but it works.
// (Even less tidy now that I've got my hands on it. -Tony)

#include <stdio.h>
#include <windows.h>

#define DEVICE1 "\\\\.\\COM1"
#define DEVICE2 "\\\\.\\COM2"
#define DEVICE3 "\\\\.\\COM3"
#define DEVICE4 "\\\\.\\COM4"
HANDLE hPort;
OVERLAPPED overlapped;

char magic[]="peace...";

// Tony Fabris 10-27-00
// This table is used by the CRC calculation to send a reboot packet.
unsigned short crc16tab[256] = {
    0x0000,  0x1021,  0x2042,  0x3063,  0x4084,  0x50a5,  0x60c6,  0x70e7,
    0x8108,  0x9129,  0xa14a,  0xb16b,  0xc18c,  0xd1ad,  0xe1ce,  0xf1ef,
    0x1231,  0x0210,  0x3273,  0x2252,  0x52b5,  0x4294,  0x72f7,  0x62d6,
    0x9339,  0x8318,  0xb37b,  0xa35a,  0xd3bd,  0xc39c,  0xf3ff,  0xe3de,
    0x2462,  0x3443,  0x0420,  0x1401,  0x64e6,  0x74c7,  0x44a4,  0x5485,
    0xa56a,  0xb54b,  0x8528,  0x9509,  0xe5ee,  0xf5cf,  0xc5ac,  0xd58d,
    0x3653,  0x2672,  0x1611,  0x0630,  0x76d7,  0x66f6,  0x5695,  0x46b4,
    0xb75b,  0xa77a,  0x9719,  0x8738,  0xf7df,  0xe7fe,  0xd79d,  0xc7bc,
    0x48c4,  0x58e5,  0x6886,  0x78a7,  0x0840,  0x1861,  0x2802,  0x3823,
    0xc9cc,  0xd9ed,  0xe98e,  0xf9af,  0x8948,  0x9969,  0xa90a,  0xb92b,
    0x5af5,  0x4ad4,  0x7ab7,  0x6a96,  0x1a71,  0x0a50,  0x3a33,  0x2a12,
    0xdbfd,  0xcbdc,  0xfbbf,  0xeb9e,  0x9b79,  0x8b58,  0xbb3b,  0xab1a,
    0x6ca6,  0x7c87,  0x4ce4,  0x5cc5,  0x2c22,  0x3c03,  0x0c60,  0x1c41,
    0xedae,  0xfd8f,  0xcdec,  0xddcd,  0xad2a,  0xbd0b,  0x8d68,  0x9d49,
    0x7e97,  0x6eb6,  0x5ed5,  0x4ef4,  0x3e13,  0x2e32,  0x1e51,  0x0e70,
    0xff9f,  0xefbe,  0xdfdd,  0xcffc,  0xbf1b,  0xaf3a,  0x9f59,  0x8f78,
    0x9188,  0x81a9,  0xb1ca,  0xa1eb,  0xd10c,  0xc12d,  0xf14e,  0xe16f,
    0x1080,  0x00a1,  0x30c2,  0x20e3,  0x5004,  0x4025,  0x7046,  0x6067,
    0x83b9,  0x9398,  0xa3fb,  0xb3da,  0xc33d,  0xd31c,  0xe37f,  0xf35e,
    0x02b1,  0x1290,  0x22f3,  0x32d2,  0x4235,  0x5214,  0x6277,  0x7256,
    0xb5ea,  0xa5cb,  0x95a8,  0x8589,  0xf56e,  0xe54f,  0xd52c,  0xc50d,
    0x34e2,  0x24c3,  0x14a0,  0x0481,  0x7466,  0x6447,  0x5424,  0x4405,
    0xa7db,  0xb7fa,  0x8799,  0x97b8,  0xe75f,  0xf77e,  0xc71d,  0xd73c,
    0x26d3,  0x36f2,  0x0691,  0x16b0,  0x6657,  0x7676,  0x4615,  0x5634,
    0xd94c,  0xc96d,  0xf90e,  0xe92f,  0x99c8,  0x89e9,  0xb98a,  0xa9ab,
    0x5844,  0x4865,  0x7806,  0x6827,  0x18c0,  0x08e1,  0x3882,  0x28a3,
    0xcb7d,  0xdb5c,  0xeb3f,  0xfb1e,  0x8bf9,  0x9bd8,  0xabbb,  0xbb9a,
    0x4a75,  0x5a54,  0x6a37,  0x7a16,  0x0af1,  0x1ad0,  0x2ab3,  0x3a92,
    0xfd2e,  0xed0f,  0xdd6c,  0xcd4d,  0xbdaa,  0xad8b,  0x9de8,  0x8dc9,
    0x7c26,  0x6c07,  0x5c64,  0x4c45,  0x3ca2,  0x2c83,  0x1ce0,  0x0cc1,
    0xef1f,  0xff3e,  0xcf5d,  0xdf7c,  0xaf9b,  0xbfba,  0x8fd9,  0x9ff8,
    0x6e17,  0x7e36,  0x4e55,  0x5e74,  0x2e93,  0x3eb2,  0x0ed1,  0x1ef0
};

/* These badly need some error checking */

static int openport(char * szWhichComPort)
{

	// Tony Fabris 10-27-00
	// CommTimeout stuff (lower down) fixes "Read 0 Bytes" error on WinNT in certain cases.
	COMMTIMEOUTS lpCommTimeouts ;
	DCB dcb;

	// Tony Fabris 10-27-00. Select Com Port with the
	// third command-line parameter (no longer hard coded).
	char DEVICE [12];
	switch( szWhichComPort [0] ) 
	{
		case '1':
			strcpy( DEVICE, DEVICE1 );
		break;
		case '2':
			strcpy( DEVICE, DEVICE2 );
		break;
		case '3':
			strcpy( DEVICE, DEVICE3 );
		break;
		case '4':
			strcpy( DEVICE, DEVICE4 );
		break;
 
		default :
			fprintf(stderr, "Error: Incorrect parameters passed to upload.\n");
			return -1;
		break;
        
	}


	hPort = CreateFile(DEVICE, GENERIC_READ | GENERIC_WRITE,
					  0 /* No sharing */, NULL /* Default security */,
					  OPEN_EXISTING, FILE_FLAG_OVERLAPPED,
					  NULL /* no template */);
	if (hPort == INVALID_HANDLE_VALUE)
	{
		fprintf(stderr, "\nError: Failed to open COM port.\n");
		return -1;
	}

	if (!GetCommState(hPort, &dcb))
	{
		CloseHandle(hPort);
		fprintf(stderr, "\nError: Failed to get comm state.\n");
		return -1;
	}

	dcb.BaudRate = CBR_115200;
	dcb.fBinary = TRUE;
	dcb.fParity = FALSE;
	dcb.fOutxCtsFlow = FALSE;
	dcb.fOutxDsrFlow = FALSE;
	dcb.fDtrControl = DTR_CONTROL_DISABLE;
	dcb.fDsrSensitivity = FALSE;
	dcb.fOutX = FALSE;
	dcb.fInX = FALSE;
	dcb.fErrorChar = FALSE;
	dcb.fNull = FALSE;
	dcb.fRtsControl = RTS_CONTROL_DISABLE;
	dcb.fAbortOnError = FALSE;
	dcb.ByteSize = 8;
	dcb.Parity = NOPARITY;
	dcb.StopBits = ONESTOPBIT;

	if (!SetCommState(hPort, &dcb))
	{
		CloseHandle(hPort);
		fprintf(stderr, "\nError: Failed to set comm state.\n");
		return -1;
	}


	overlapped.hEvent = CreateEvent(NULL,  TRUE /* manual reset */,
									FALSE, /* initially non-signalled */
									NULL);  
	if (overlapped.hEvent == NULL)
	{
		CloseHandle(hPort);
		fprintf(stderr, "\nFailed to create event.\n");
		return -1;
	}


	// Tony Fabris 10-27-00
	// Okay, essentially what I'm doing here is this...
	// I packet-sniffed what Hyperterminal does when it connects to the Empeg. Since
	// Hyperterminal clears the "Read 0 Bytes" error, it would follow that I could clear
	// the error by emulating what Hyperterminal does. Okay, here goes...

	// AHA! THIS WAS IT!!!!!:
	lpCommTimeouts.ReadIntervalTimeout = 0x10;
	lpCommTimeouts.ReadTotalTimeoutMultiplier = 0;
	lpCommTimeouts.ReadTotalTimeoutConstant = 0;
	lpCommTimeouts.WriteTotalTimeoutMultiplier = 0;
	lpCommTimeouts.WriteTotalTimeoutConstant = 0x5000;
	SetCommTimeouts (hPort, &lpCommTimeouts);
	//BAHAHAHAHAHAHAHAHAHA!!!!!!! THANK YOU PORTMON!!!!!!

	return 0;
}

static void closeport()
{
	CloseHandle(overlapped.hEvent);
	overlapped.hEvent = NULL;
	CloseHandle(hPort);
	hPort = INVALID_HANDLE_VALUE;
}

static int readbyte(int wait)
{
	DWORD dwRead;
	DWORD dwBytes;
	unsigned char ch = 0;
	DWORD dwErrors;
	
	ClearCommError(hPort, &dwErrors, NULL);
	if (dwErrors)
		fprintf(stderr, "Error status in readbyte %ld\n", dwErrors);

	if (!ReadFile(hPort, &ch, 1, &dwRead, &overlapped))
	{
		if (GetLastError() == ERROR_IO_PENDING)
		{
			// We've been deferred, wait for it.
			switch(WaitForSingleObject(overlapped.hEvent, wait * 1000))
			{
			case WAIT_OBJECT_0:
				/* We succeeded */
				break;
			case WAIT_TIMEOUT:
				/* We timed out */
				//fprintf(stderr, "Read timed out\n");
				PurgeComm(hPort, PURGE_RXABORT);
				//CancelIo(hPort);
				return -1;
			case WAIT_ABANDONED:
				/* We were abandoned, did the hEvent go away? */
				fprintf(stderr, "WaitForSingleObject abandoned\n");
				PurgeComm(hPort, PURGE_RXABORT);
				//CancelIo(hPort);
				return -1;
			case WAIT_FAILED:
			default:
				fprintf(stderr, "\nWaitForSingleObject failed %d\n", GetLastError());
				PurgeComm(hPort, PURGE_RXABORT);
				//CancelIo(hPort);
				return -1;
			}

			if (!GetOverlappedResult(hPort, &overlapped, &dwBytes, TRUE))
			{
				fprintf(stderr, "\nGetOverlappedResult failed with error %ld\n", GetLastError());
				return -1;
			}
			if (!dwBytes)
			{
				// Tony Fabris 10-27-00
				// This is a very strange error. It happens under WindowsNT if you run this
				// program immediately after running EmpegUpgrade.exe.

				// Note: The original code didn't dump them out of the program. However, since
				// the flash fails in this case, I thought it best if I went ahead and dumped them.

				// Also note: I think I fixed the bug by setting the comm timeouts when we open
				// the port (see that section of the code for details). So this error shouldn't
				// ever come up anyway. :-)
				closeport();
			   printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
				fprintf(stderr, "\nERROR: Read 0 bytes.\n\nA previous application has left the COM port in a locked state.\nYou may need to reboot the computer or reset the COM port.\n\n");
				fprintf(stderr, "\n\n\n\n\nPress the Enter key to continue.\n\n");
				getchar();
				exit(13);
			}
		}
		else
		{
			fprintf(stderr, "\nRead failed %ld\n", GetLastError());
			return -1;
		}
	}
	else
	{
		if (dwRead == 0)
		{
			// Tony Fabris 10-27-00
			// Stiffer error message and full exit.
			closeport();
			printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
			fprintf(stderr, "\nERROR: Zero byte read.\n\nA previous application has left the COM port in a locked state.\nYou may need to reboot the computer or reset the COM port.\n\n");
			fprintf(stderr, "\n\n\n\n\nPress the Enter key to continue.\n\n");
			getchar();
			exit(13);
		}
	}
	return ch;
}

static void writebyte(int byte)
{
	DWORD dwWritten;
	unsigned char ch = byte;
	DWORD dwErrors;

	ClearCommError(hPort, &dwErrors, NULL);
	if (dwErrors)
		fprintf(stderr, "CommError in writebyte %ld\n", dwErrors);
	
	if (!WriteFile(hPort, &ch, 1, &dwWritten, &overlapped))
	{
		DWORD dwBytes;
		if (GetLastError() == ERROR_IO_PENDING)
		{
			// We've been deferred, wait for it.
			if (WaitForSingleObject(overlapped.hEvent, 10000) != WAIT_OBJECT_0)
			{
				// We failed. Cancel it.
				PurgeComm(hPort, PURGE_TXABORT);
				//CancelIo(hPort);
				fprintf(stderr, "\nWaitForSingleObject failed with error %d\n", GetLastError());
			}
			if (!GetOverlappedResult(hPort, &overlapped, &dwBytes, FALSE))
			{
				fprintf(stderr, "\nGetOverlappedResult failed with error %ld\n", GetLastError());
			}
			if (!dwBytes)
			{
				fprintf(stderr, "Wrote 0 bytes.\n");
			}
			else
			{
				//fprintf(stderr, "Write succeeded after time %c (%d).\n", ch, ch);
			}
		}
		else
		{
			fprintf(stderr, "\nWrite failed %ld\n", GetLastError());
		}
	}
	else
	{
		if (dwWritten == 0)
			fprintf(stderr, "Strange, we got a zero byte write\n");
	}
}

static void writebytes(unsigned char * bytes, int numbytes)
{
	DWORD dwWritten;
	//unsigned char ch = byte;
	DWORD dwErrors;

	ClearCommError(hPort, &dwErrors, NULL);
	if (dwErrors)
		fprintf(stderr, "CommError in writebyte %ld\n", dwErrors);
	
	if (!WriteFile(hPort, bytes, numbytes, &dwWritten, &overlapped))
	{
		DWORD dwBytes;
		if (GetLastError() == ERROR_IO_PENDING)
		{
			// We've been deferred, wait for it.
			if (WaitForSingleObject(overlapped.hEvent, 10000) != WAIT_OBJECT_0)
			{
				// We failed. Cancel it.
				PurgeComm(hPort, PURGE_TXABORT);
				//CancelIo(hPort);
				fprintf(stderr, "\nWaitForSingleObject failed with error %d\n", GetLastError());
			}
			if (!GetOverlappedResult(hPort, &overlapped, &dwBytes, FALSE))
			{
				fprintf(stderr, "\nGetOverlappedResult failed with error %ld\n", GetLastError());
			}
			if (!dwBytes)
			{
				fprintf(stderr, "Wrote 0 bytes.\n");
			}
			else
			{
				//fprintf(stderr, "Write succeeded after time %c (%d).\n", ch, ch);
			}
		}
		else
		{
			fprintf(stderr, "\nWrite failed %ld\n", GetLastError());
		}
	}
	else
	{
		if (dwWritten == 0)
			fprintf(stderr, "Strange, we got a zero byte write\n");
	}
}

static void flushrx()
  {
  // Tony Fabris 2002-10-22
  // Attempt to fix long-standing bug in flash timings. This particular
  // change (delay 1 second instead of 0 seconds on each flushrx) was
  // suggested by Jan Harkes. I avoided it at first because I thought
  // it would slow things down too much. But now it seems to be just
  // what the doctor ordered. Thanks, Jan.
  while(readbyte(1)>=0);
  }

static int readhex(int timeout,int digits)
  {
  char buffer[16];
  int a,d,result;

  // Read hex data
  for(a=0;a<digits;a++)
    {
    if ((d=readbyte(timeout))<0) return(-1);
    buffer[a]=d;
    }
  buffer[digits]=0;

  // Parse it
  if (sscanf(buffer,"%x",&result)!=1) return(-2);
  return(result);
  }

static int erasepage(int address)
  {
  int res;

  // Tony Fabris 2002-10-20 More attemtps to fix erase command error.
  Sleep(100);

  // Empty buffer first
  flushrx();

  // Tony Fabris 2002-10-20 More attemtps to fix erase command error.
  Sleep(100);


  // Send command
  writebyte('e');

  // Tony Fabris 2002-10-17 Attempt to fix old long-standing
  // bug of erase command error by sleeping after the writebyte.
  // Based on Mark Lord's suggestion which fixed the lockpage error.
  Sleep(100);

  if (readbyte(1)!='e')
  {
	  fprintf(stderr, "\nFailed to get echo-back on erase command.\n");
	  return(1);
  }
  
  // Send address
  writebyte((address>> 0)&0xff);
  writebyte((address>> 8)&0xff);
  writebyte((address>>16)&0xff);
  writebyte((address>>24)&0xff);

  // Get 8-byte hex address reply and see if it matches
  if (readhex(1,8)!=address) return(2);

  // Should now have a '-' showing it's working on the erase
  if (readbyte(1)!='-') return(3);

  // Read result (leave 2 seconds)
  if ((res=readhex(2,2))!=0x80) return(0x100+res);

  return(0);
  }

static int lockpage(int address, int locktype)
{
  int res,command=(locktype==0?'u':'l');

  // Empty buffer first
  flushrx();

  // Tony Fabris 2002-10-20 More attempts to fix timing errors for certain users.
  Sleep(100);

  // Send command
  writebyte(command);

  // Tony Fabris 2002-10-20 More attempts to fix timing errors for certain users.
  Sleep(100);


  if (readbyte(1)!=command)
  {
	  fprintf(stderr, "\nFailed to get echo-back on lock/unlock command.\n");
	  return(1);
  }
  
  // Send address
  writebyte((address>> 0)&0xff);
  writebyte((address>> 8)&0xff);
  writebyte((address>>16)&0xff);
  writebyte((address>>24)&0xff);

  // Get 8-byte hex address reply and see if it matches
  if (readhex(1,8)!=address) return(2);

  // Should now have a '-' showing it's working on the lock
  if (readbyte(1)!='-') return(3);

  // Read result (leave 2 seconds)
  if ((res=readhex(2,2))!=0x80) return(0x100+res);

  return(0);
  }

static int program(char *buffer,int address,int length)
  {
  int checksum,a;

  // Empty buffer first
  flushrx();

  // Send command
  writebyte('p');
  if (readbyte(1)!='p') return(1);

  // Send address
  writebyte((address>> 0)&0xff);
  writebyte((address>> 8)&0xff);
  writebyte((address>>16)&0xff);
  writebyte((address>>24)&0xff);

  // Get 8-char hex address reply and see if it matches
  if (readhex(1,8)!=address) return(2);

  // Should now have a '-' showing it's waiting for length
  if (readbyte(1)!='-') return(3);

  // Send length
  writebyte((length>> 0)&0xff);
  writebyte((length>> 8)&0xff);
  
  // Get 4-char hex length reply and see if it matches
  if (readhex(1,4)!=length) return(4);

  // Should now have a '-' showing it's waiting for data
  if (readbyte(1)!='-') return(5);

  // Send data
  for(a=checksum=0;a<length;a++)
    {
    checksum+=buffer[a];
    writebyte(buffer[a]);
    }

  // Send checksum
  writebyte(checksum&0xff);

  // Should get an 'ok' indicating good download
  if (readbyte(1)!='o') return(6);
  if (readbyte(1)!='k') return(7);
  if (readbyte(1)!='\r') return(8);
  if (readbyte(1)!='\n') return(9);

  // Should have program reply within a second
  if (readbyte(1)!='o') return(10);
  if (readbyte(1)!='k') return(11);
  
  // All ok
  return(0);
  }

// Calculate CRC to build reboot packet.
unsigned short CRC16(unsigned char *buffer, int length)
{
	unsigned short crc=0;
	while(length--) crc=(crc16tab[((crc>>8)&255)]^(crc<<8)^(*buffer++));
	return(crc);
}

int main(int argc, char *argv[])
{

			// Tony Fabris 10-27-00
			// Build packets that tell the player to reboot...
			unsigned char mybytes1[2] = { 0x19, 0x0d };
			unsigned char mybytes5[279] = { 0x02, 0x0C, 0x01, 0x0C, 0x00, 0x2D, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}; 
			unsigned short crc=CRC16(((unsigned char*)mybytes5)+2+1,268+1+1+4);
			// CRC bounds...
			// The +2+1 means: CRC doesn't start counting until after
			// the PSOH (0x02), the command (0x0C), and the size (0x010C).
			// The 268+1+1+4 means: CRC ends at the end of the data stream:
			// 268=size of the "meat" of the data, +1+1+4 is remainder of
			// packet header. Yes, this is all very kludgy but it works.

  FILE *i;
  int d,err,start,length,done,magicpos;
  int manufacturer,product;
  int erase_pos,erase_end,pagesize,lock_pos,lock_end;

  if (argc<4 || argc>5) {
    fprintf(stderr,"\nusage %s <file> <address in hex> <com port>\n\n", argv[0]);
    exit(1);
  }
  
  /* Open player device & setup */
  if (openport(argv[3])) {

	 // Tony Fabris 10-27-00
	 // Stiffer error message. Added Getchar because I want the user
	 // to see the error message since I'm shelling to this program
	 // from Windows and it would disappear if I didn't.
	printf("\n\n");
   printf("----------------------------------\n");
   printf("- ERROR: Couldn't open com port. -\n");
   printf("----------------------------------\n");
   printf("\n\n");

		printf("\n       Press the Enter key to continue.\n");
		getchar();

    exit(2);
  }


  if (argc<5) {

	// Tony Fabris 10-27-00
	// Send reboot data to the player.
   printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
   printf("Trying to reboot the player now...\n");
	// Make sure the last two bytes of that packet are the CRC.
	*(mybytes5+277)=(crc&0xff);
	*(mybytes5+278)=(crc>>8);
	// Send Attention signal
	writebytes (mybytes1, 2);
	Sleep (100);
	// Send reboot packet.
	writebytes (mybytes5, 279);
	// Don't send data while the unit is actually rebooting.
	Sleep (1000);


    /* Tell user to power up the device */
	// Tony Fabris 10-27-00
	// more detailed message. This message will scroll off
	// the screen as soon as it begins the write, so if the
	// reboot packet worked, then this will go away and the
	// data upload will begin.

    printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
    printf("-----------------------------------------------\n");
    printf("-         READY TO BEGIN SENDING DATA         -\n");
    printf("-                                             -\n");
    printf("- The player should reboot and the data       -\n");
    printf("- transfer should begin automatically. If     -\n");
    printf("- this doesn't happen within the next few     -\n");
    printf("- seconds, then do the following:             -\n");
    printf("-                                             -\n");
    printf("- UNPLUG the power from the empeg car player, -\n");
    printf("- then PLUG IT IN again to begin the data     -\n");
    printf("- transfer process.                           -\n");
    printf("-                                             -\n");
    printf("-             Please do this now.             -\n");
    printf("-----------------------------------------------\n");
    printf("\n");



    magicpos=0;
    while(1) {
      //Look for magic string 
      d=readbyte(1);
      if (d<0) magicpos=0;
      else {
				if (d==magic[magicpos]) {
												magicpos++;
												if (magic[magicpos]==0) break;
												}
												else magicpos=(d==magic[0])?1:0;
				}
		 }

    printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
    printf("found empeg unit: entering program mode\n");
    writebyte(1);

    /* Manufacturer ID: Look for '#' then 4 hex digits */
    while((d=readbyte(1))>0 && d!='#');
    if (d<0) {
      printf("\nError: Couldn't find manufacturer ID!\n");

		printf("\n       Press the Enter key to continue.\n");
		getchar();

      exit(10);
    }
    manufacturer=readhex(1,4);

    /* Product ID: Look for '#' then 4 hex digits */
    while((d=readbyte(1))>0 && d!='#');
    if (d<0) {
      printf("\nError: Couldn't find product ID!\n");
		printf("\n       Press the Enter key to continue.\n");
		getchar();
      exit(11);
    }
    product=readhex(1,4);
    
    printf("manufacturer=%04x, product=%04x\n",manufacturer,product);
  } else {
    /* Send a cr to get a prompt back */
    writebyte(13);
  }

  printf("waiting for prompt\n");
  while((d=readbyte(1))>0 && d!='?');
  if (d<0) {
    printf("\nError: No prompt within timeout\n");
	 printf("\n       Press the Enter key to continue.\n");
	 getchar();
    exit(12);
  }
  printf("starting erase [");
  fflush(stdout);
  
  /* Size binary file */
  if ((i=fopen(argv[1],"rb"))==NULL) {
    fprintf(stderr,"\nError: Can't open input '%s'\n",argv[1]);
	 printf("\n       Press the Enter key to continue.\n");
	 getchar();
    exit(3);
  }
  
  fseek(i,0L,SEEK_END);
  length=ftell(i);
  fseek(i,0L,SEEK_SET);
  
  /* Get address */
  if (sscanf(argv[2],"%x",&start)!=1) {
    fprintf(stderr,"\nError: Can't parse start address '%s'\n",argv[2]);

 	 printf("\n       Press the Enter key to continue.\n");
	 getchar();

    exit(4);
  }
  
  /* Erase pages that need erasing */
  lock_pos=erase_pos=(start&~0x1fff);
  lock_end=erase_end=(start+length-1)&~0x1fff;

  done=0;
  while(erase_pos<=erase_end) {
      /* Work out the pagesize for this bit */
      pagesize=(erase_pos<0x10000)?0x2000:0x10000;

      /* If we've got a C3 flash, we need to unlock the page first */
      if (product==0x88c1) {
	if ((err=lockpage(erase_pos,0))!=0) {
	  fprintf(stderr,"\nError: lockpage(%x,0) got code %x\n",erase_pos,err);

	  printf("\n       Press the Enter key to continue.\n");
	 getchar();

	  exit(5);
	  }
      }
	
      /* Do the erase */
      if ((err=erasepage(erase_pos))!=0) {
	fprintf(stderr,"\nError: erasepage(%x) got code %x\n",erase_pos,err);

	 printf("\n       Press the Enter key to continue.\n");
	 getchar();

	exit(5);
      }

      erase_pos+=pagesize;
      done+=pagesize;

      printf("%3d%%\010\010\010\010",(done*100)/length);
      fflush(stdout);
  }
	   
  /* Erase done */
  printf("100%%] erase ok\nstarting program at 0x%x [",start);
  fflush(stdout);
  
  /* Do programming */
  done=0;
  while(done<length) {
    char block[16384];
    int blocklength=((length-done)>16384)?16384:(length-done);
    
    if (blocklength&1) blocklength++;

    /* Read block */
    fread(block,1,blocklength,i);

    /* Program data */
    if ((err=program(block,start,blocklength))!=0) {
      fprintf(stderr,"\nError: program(%x) got code %x\n",start,err);
      	 printf("\n       Press the Enter key to continue.\n");
				getchar();
		exit(6);
    }
    
    start+=blocklength;
    done+=blocklength;
    printf("%3d%%\010\010\010\010",(done*100)/length);
    fflush(stdout);
  }
  // Tony Fabris 2002/10/17:
  // Suggestion by Mark Lord to fix the lockpage error bug.
  // Sleep for 1 second before closing the file.
  Sleep(100);
  fclose(i);
  
  /* C3 flash? */
  if (product==0x88c1) {
    /* Lock all the pages again */
    while(lock_pos<=lock_end) {
      /* Work out the pagesize for this bit */
      pagesize=(lock_pos<0x10000)?0x2000:0x10000;

      if ((err=lockpage(lock_pos,1))!=0) {
	fprintf(stderr,"\nError: lockpage(%x,1) got code %x\n",lock_pos,err);

		 printf("\n       Press the Enter key to continue.\n");
		 getchar();

	exit(5);
      }
      lock_pos+=pagesize;
    }
  }

  // Tony Fabris 10-27-00
  // Cooler program-OK message. I think I did this because
  // one early user reported that he didn't know whether the
  // upload worked or not. So, now they have no excuse, a big
  // happyface appears on the screen and hangs around for five
  // seconds.
    
  printf("100%%]\n\n\n");

    printf("                 PROGRAM OK                  \n");
    printf("                  ________                   \n");
    printf("                 / /    \\ \\                  \n");
    printf("                /   O  O   \\                 \n");
    printf("               /  _      _  \\                \n");
    printf("               \\  \\\\____//  /                \n");
    printf("                \\  \\____/  /                 \n");
    printf("                 \\________/                  \n");
    // Trust me, on the screen, that ends up looking like a happy-face.

	// Tony Fabris 10-27-00
	// Soft-reboot the player after sending valid data, so they
	// can see their handiwork. NOTE: With some kernels, this
	// causes the garbage screen. Check out what research Richard
	// Lovejoy and Brian Mihulka are doing on the subject...
	writebyte ('r');
	writebyte ('\n');
 
	closeport();

	// Tony Fabris 10-27-00, hang around on the screen for 5 seconds
	// (remember, we're shelling from Windows here...
	Sleep (5000);

  return 0;
}



